<!DOCTYPE html>
<html>

<head>
  <title> Task 25.30 ... Tạo đơn hàng - xem chi tiết </title>
  <meta charset='utf-8'>
  <meta name='viewport' content='width=device-width, initial-scale=1'>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageLoading()">
  <div class="container jumbotron">
    <div class="col-12">
      <div class="text-center mb-5"> <h1> Create Order </h1> </div>
        <div class="form-group row">
          <label for="" class="col-sm-2 col-form-label">Cỡ Combo</label>
          <div class="col-sm-4">
            <select class="form-control" id="select-size">
              <option value="0" > Chọn cỡ Combo (Combo size)</option>
              <option value="S">Nhỏ</option>
              <option value="M"> Vừa</option>
              <option value="L"> Lớn</option>
            </select>
          </div>
          <label for="" class="col-sm-2 col-form-label">Đồ uống</label>
          <div class="col-sm-4">
            <select class="form-control" id="select-drink">
              <option value="0">Chọn đồ uống</option>
            </select>
          </div>
        </div> 
        <div class="form-group row">
          <label class="col-sm-2 col-form-label">Mã voucher</label>
          <div class="col-sm-4">
            <input type="text" class="form-control" placeholder="Voucher ID (mã voucher)" id="input-voucher">
          </div>
          <label class="col-sm-2 col-form-label">Loại pizza</label>
          <div class="col-sm-4">
            <select class = "form-control" id="select-pizza">            <!-- select chưa có id, các option chưa có value-->
              <option value="0"> Chọn loại pizza </option>
              <option value = "Seafood" > Hải sản</option>
              <option value = "Hawaii"> Ha wai </option>
              <option value = "Bacon" > Thịt hun khói </option>
            </select>
          </div>        
        </div>
        <div class="form-group row">
          <label class="col-sm-2 col-form-label" for="">Họ và tên</label>
          <div class="col-sm-4">
            <input type="text" class="form-control" placeholder="Họ và tên" id="input-full-name"> 
          </div>
          <label for="" class="col-sm-2 col-form-label">Email</label>
          <div class="col-sm-4">
            <input type="email" class="form-control" placeholder="Email" id="input-email"> 
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-2 col-form-label">Số điện thoại</label>
          <div class="col-sm-4">
            <input type="text" class="form-control" placeholder="Số điện thoại" id="input-sdt">
          </div>
          <label class="col-sm-2 col-form-label">Địa chỉ</label>
          <div class="col-sm-4">
            <input type="text" class="form-control" placeholder="Địa chỉ" id="input-dia-chi"> 
          </div>
        </div>
        <div class="form-group">
          <label>Lời nhắn</label>
          <textarea class="form-control h-75" placeholder="Lời nhắn" id="textarea-message"></textarea>
        </div> 
        <div class="form-group">
          <button onclick="onBtnCreateOrderClick()" class="btn btn-primary">Create Order</button>
          <button  class="btn btn-secondary" id="btn-show" onclick="onBtnShowDataOrderClick()">Show Order Data in New Form</button>
        </div>
    </div>
  </div>
  <script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201; //TRẠNG THÁI 201 TẠO ĐƠN HÀN THÀNH CÔNG
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-pizza365/orders";
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
      // load dữ liệu vào select car
      loadDataDrinkList();
    }
    //hàm thực hiện sự kiện nút bấm 
    function onBtnCreateOrderClick(){
      "use strict";
      console.log("%cNút Create order được ấn","color: orange");
      //khai báo đối tượng chứa dữ liệu
      var vOrderObj = {
        kichCo: "",
        duongKinh: "",
        suon: "",
        salad: "",
        loaiPizza: "",
        idVoucher: "",
        idLoaiNuocUong: "",
        soLuongNuoc: "",
        hoVaTen: "",
        thanhTien: "",
        email: "",
        soDienThoai: "",
        diaChi: "",
        loiNhan: "",
      }
      //b1: thu thập dữ liệu
      readDataInput(vOrderObj);
      //b2: kiểm tra dữ liệu  
      var vDuLieuHopLe = validateData(vOrderObj);
      if(vDuLieuHopLe){
        //b3: gọi api
        var vXmlHttp = new XMLHttpRequest();
        callApiCreateOrder(vXmlHttp, vOrderObj);
        //b4: hiển thị thông tin
        vXmlHttp.onreadystatechange = 
        function (){
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS) { // status 201 tao thanh cong
                  headlerCreateData(vXmlHttp);
                }
            }
        }
    }
    
    function onBtnShowDataOrderClick(){
      "use strict";
      var vElementButtonShowOrder = document.getElementById("btn-show");
      var vGetOrderCode = vElementButtonShowOrder.dataset.ordercode;
      console.log("Order Code là: ", vGetOrderCode);

      const vDETAIL_URL = "orderDetail.html";
      var vOpenUrl = vDETAIL_URL + "?" + "orderCode=" + vGetOrderCode;
      window.location.href = vOpenUrl;
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //hàm thu thập dữ liệu
    function readDataInput(paramOrder){
      var vSelectCombo = document.getElementById("select-size");
      paramOrder.kichCo = vSelectCombo.value;

      var vSelectDoUong = document.getElementById("select-drink");
      paramOrder.idLoaiNuocUong = vSelectDoUong.value;

      var vInputMaVoucher = document.getElementById("input-voucher");
      paramOrder.idVoucher = vInputMaVoucher.value.trim();

      var vSelectLoaiPizza = document.getElementById("select-pizza");
      paramOrder.loaiPizza = vSelectLoaiPizza.value;

      var vInputHoVaTen = document.getElementById("input-full-name");
      paramOrder.hoVaTen = vInputHoVaTen.value.trim();

      var vInputEmail = document.getElementById("input-email");
      paramOrder.email = vInputEmail.value.trim();

      var vInputSoDienThoai = document.getElementById("input-sdt");
      paramOrder.soDienThoai = vInputSoDienThoai.value.trim();

      var vInputDiaChi = document.getElementById("input-dia-chi");
      paramOrder.diaChi = vInputDiaChi.value.trim();

      var vTextareaLoiNhan = document.getElementById("textarea-message");
      paramOrder.loiNhan = vTextareaLoiNhan.value.trim();

      if(paramOrder.kichCo == "S"){
        paramOrder.duongKinh = 20;
        paramOrder.suon = 2;
        paramOrder.salad = 200;
        paramOrder.soLuongNuoc = 2;
        paramOrder.thanhTien = 150000;
      }
      else if(paramOrder.kichCo == "M"){
        paramOrder.duongKinh = 24;
        paramOrder.suon = 4;
        paramOrder.salad = 300;
        paramOrder.soLuongNuoc = 3;
        paramOrder.thanhTien = 200000;
      }
      else if(paramOrder.kichCo == "L"){
        paramOrder.duongKinh = 30;
        paramOrder.suon = 8;
        paramOrder.salad = 500;
        paramOrder.soLuongNuoc = 4;
        paramOrder.thanhTien = 250000;
      }

    }

    //hàm kiểm tra dữ liệu
    function validateData(paramOrder){
      "use strict";
      if(paramOrder.kichCo == 0){
        alert("bạn cần chọn combo");
        return false;
      }
      if(paramOrder.idLoaiNuocUong == 0){
        alert("bạn cần chọn nước uống");
        return false;
      }
      if(paramOrder.idVoucher == ""){
        alert("Bạn cần nhập mã voucher");
        return false;
      }
      if(paramOrder.loaiPizza == 0){
        alert("Bạn cần chọn loại Pizza");
        return false;
      }
      if(paramOrder.hoVaTen == ""){
        alert("Hãy nhập họ và tên");
        return false;
      }
      if(paramOrder.email == ""){
        alert("Hãy nhập email");
        return false;
      }
      if(paramOrder.soDienThoai == ""){
        alert("Hãy nhập số điện thoại");
        return false;
      }
      if(paramOrder.diaChi == ""){
        alert("Hãy nhập địa chỉ");
        return false;
      }
      if(paramOrder.loiNhan == ""){
        alert("Hãy nhập lời nhắn");
        return false;
      }
      return true;
    }

    //hàm gọi Api tạo một order
    function callApiCreateOrder(paramXmlHttp, paramObj) {
        "use strict";
        paramXmlHttp.open("POST", gBASE_URL, true);
        paramXmlHttp.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        paramXmlHttp.send(JSON.stringify(paramObj));
        console.log(paramObj);
    }

    //hàm xử lý hiển thị khi request thành công 
    function headlerCreateData(paramXmlHttp){
      "use strict";
      var vCreatedOrder = paramXmlHttp.responseText;
      console.log(vCreatedOrder);
      //chuyern dữ liệu Json về Obj
      var vOrderObj = JSON.parse(paramXmlHttp.responseText);
      //táo biến chứa Order code của obj
      var vOrderCode = vOrderObj.orderCode;
      //ghi giá trị nhận về vào dataset của nút Show order dâta in new form
      var vElementBtnShowOrder = document.getElementById("btn-show");
      vElementBtnShowOrder.dataset.ordercode = vOrderCode;

      console.log("%cOrderCode là: " + vOrderCode,"color: purple");
    }

    // Hàm thực hiện call api để load dữ liệu vào drink list
    function loadDataDrinkList() {
      var vXhttp = new XMLHttpRequest();
      vXhttp.open("GET", "http://203.171.20.210:8080/devcamp-pizza365/drinks", true);
      vXhttp.send();
      vXhttp.onreadystatechange = function () {
          if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
            console.log(vXhttp.responseText); // ghi response text ra console.log
            handleLoadDataToSelectDrink(vXhttp);
          }
        };
    }

    // handle data load to select drink
    function handleLoadDataToSelectDrink(paramXhttp) {
      var vArrayDrinkList = JSON.parse(paramXhttp.responseText);
      console.log("array drink list = " + vArrayDrinkList.length);
      //load data to drink select
      var vElementSelectDrink = document.getElementById("select-drink");
      for (var bIterator = 0; bIterator < vArrayDrinkList.length; bIterator++) {
        var vDrinkOptionElement = document.createElement("option");
        vDrinkOptionElement.value = vArrayDrinkList[bIterator].maNuocUong;
        vDrinkOptionElement.text = vArrayDrinkList[bIterator].tenNuocUong;
        vElementSelectDrink.appendChild(vDrinkOptionElement);
      }
    }
  </script>


</body>

</html>